﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using System.Collections;
using Syncfusion.Windows.Forms.Tools;

namespace WindowsFormsApplication4
{
    public partial class Form1 : Form
    {
        
        private List<String>mSegmentList = new List<String>();
        
        public Form1()
        {
            InitializeComponent();
        }

        private void loadListBox()
        {
            string path = @"print segments.txt";
            foreach (string line in File.ReadLines(path))
            {
                
                mSegmentList.Add(line.Trim());
               
                cboSegment.AutoCompleteCustomSource.Add(line.Trim()); 
            }
            cboSegment.DataSource = mSegmentList;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            loadListBox();
          
        }

        int cboNum = 0;

        private void btnAdd_Click(object sender, EventArgs e)
        {
            //TextBox txtSeg = new TextBox();
            //txtSeg.Text = cboSegment.Text;
            //AutoSizeTextBox(txtSeg);

//            txtSeg.Location = new Point(mYlocation, 30);
  //          mYlocation += txtSeg.Width + 10;

    //        this.Controls.Add(txtSeg);

            ComboBoxAutoComplete mCboSegment = new ComboBoxAutoComplete();
            List<String> mNewList = mSegmentList.ToList<String>();
            mCboSegment.DataSource = mNewList;

            mCboSegment.AutoCompleteCustomSource.AddRange(mSegmentList.ToArray<String>());
            //mCboSegment.AutoCompleteCustomSource.AddRange({ "One","two","three"});
            mCboSegment.AutoCompleteSource = AutoCompleteSource.CustomSource;
            mCboSegment.Location = new Point(mYlocation, 20);
            mCboSegment.AutoCompleteMode = AutoCompleteMode.SuggestAppend;
            mCboSegment.SelectedItem = 1;
            mCboSegment.SelectedValueChanged += new EventHandler(MCboSegment_SelectedValueChanged);
            mCboSegment.Tag = cboNum;
            mCboSegment.DropDownWidth = 600;
            mCboSegment.AllowNewText = false;
            cboNum++;
            mYlocation += mCboSegment.Width + 10;
            //this.Controls.Add(mCboSegment);
           
            grpCombo.Controls.Add(mCboSegment);
        }

        private void MCboSegment_SelectedValueChanged(object sender, EventArgs e)
        {
            AutoSizeComboBox((ComboBoxAutoComplete)sender);
        }

        int mYlocation = 10;

        private void txtPrintSegment_DoubleClick(object sender, EventArgs e)
        {
            


            

        }



        private void AutoSizeTextBox(TextBox txt)
        {
            const int x_margin = 0;
            const int y_margin = 2;
            Size size = TextRenderer.MeasureText(txt.Text, txt.Font);
            txt.ClientSize =
            new Size(size.Width + x_margin, size.Height + y_margin);
        }

        private void AutoSizeComboBox(ComboBoxAutoComplete cbo)
        {
            const int x_margin = 50;
            const int y_margin = 200;
            String selectedText = (cbo.Text.Length == 0) ? "Place Holder" : cbo.Text;
            Size size = TextRenderer.MeasureText(selectedText, cbo.Font);
            cbo.ClientSize =
            new Size(size.Width + x_margin, size.Height + y_margin);
            resizeGroup();
        }

        private void resizeGroup()
        {
            int x = 10;
           foreach (Control cnt in grpCombo.Controls)
            {
              
                if ((Int32)cnt.Tag != 0)
                {
                    cnt.Location = new Point(x, 20);
                }
                x += cnt.Width + 10;
            }
        }

        private void txtPrintSegment_TextChanged(object sender, EventArgs e)
        {
            AutoSizeTextBox(sender as TextBox);
        }


    }
}
